<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task33.20 update user form</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script> 
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script> 
</head>
<body>
    <div class = "container jumbotron">
        <div class = "text-center mb-4">
            <h3>Chi tiết user</h3>
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <label>First Name</label>
            </div>
            <div class = "col-sm-8">
                <input id="input-firstname" class = "form-control" placeholder="Nhập Firstname...">
            </div>
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <label>Last Name</label>
            </div>
            <div class = "col-sm-8">
                <input id="input-lastname" class = "form-control" placeholder="Nhập Lastname...">
            </div>
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <label>Subject</label>
            </div>
            <div class = "col-sm-8">
                <input id="input-subject" class = "form-control" placeholder="Nhập Subject...">
            </div>
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <label>Country</label>
            </div>
            <div class = "col-sm-8">
                <select id="select-country" class = "form-control">
                    <option value="VN">Việt Nam</option>
                    <option value="USA">USA</option>
                    <option value="AUS">Australia</option>
                    <option value="CAN">Canada</option>
                </select>
            </div>
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <label>Customer Type</label>
            </div>
            <div class = "col-sm-8">
                <select id="select-customer-type" class = "form-control">
                    <option value="Standard">Standard</option>
                    <option value="Gold">Gold</option>
                    <option value="Premium">Premium</option>
                </select>
            </div>
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <label>Register Status</label>
            </div>
            <div class = "col-sm-8">
                <select id="select-register-status" class = "form-control">
                    <option value="New">New</option>
                    <option value="Accepted">Accepted</option>
                    <option value="Denied">Denied</option>
                </select>
            </div>
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">

            </div>
            <div class = "col-sm-8">
                <button id = "btn-update-user" class = "btn btn-success w-25"> Update user</button>
                <button id = "btn-cancel" class = "btn btn-success w-25"> Hủy bỏ</button>
            </div>
        </div>
        
    </div>
</body>
<script>
     "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    //định nghĩa các biến input trong form
    var gElementFirstName = $("#input-firstname");
    var gElementLastName = $("#input-lastname");
    var gElementSubject = $("#input-subject");
    var gElementCountry = $("#select-country");
    var gElementCustomerType = $("#select-customer-type");
    var gElementRegisterStatus = $("#select-register-status");
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function(){
        onPageLoading();
    });
    $("#btn-update-user").click(function(){//hàm xử lý sự kiện update user
        console.log("Update user click.....");
        //b1: get data from form
        var vUserObject = getFormData();
        //b2: validate
        var vCheck = validateFormData(vUserObject);
        if (vCheck){
            //b3: gọi API update user info
            callAjaxApiUpdateUser(vUserObject);
        }
    });
    
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm xử lý sự kiện tải trang
    function onPageLoading(){
        "use strict";
        var vUrlString = window.location.href;
        var vUrl = new URL(vUrlString);
        //search param
        var vId = vUrl.searchParams.get("id");
        console.log("Id của user là: " + vId);
        callApiGetDataUserById(vId);
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function getCurrentUserId(){
        //thu thập dữ liệu từ query string
        var vUrlString = window.location.href;
        var vUrl = new URL(vUrlString);
        //search param
        var vId = vUrl.searchParams.get("id");
        return vId;
    }
    function callApiGetDataUserById(paramUserId) {
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/" + paramUserId,
            type: "GET",
            dataType: "json",
            success: function (paramDataUserObj){
                console.log(paramDataUserObj);
                showDataUserToForm(paramDataUserObj);
            },
            error: function (ajaxContext) {
                alert(ajaxContext.responseText);
            },
        });        
    }
    //hàm hiển thị dữ liệu lên form
    function showDataUserToForm(paramDataUserObj){
        "use strict";
        $("#input-firstname").val(paramDataUserObj.firstname);
        $("#input-lastname").val(paramDataUserObj.lastname);
        $("#select-country").val(paramDataUserObj.country);
        $("#input-subject").val(paramDataUserObj.subject);
        $("#select-customer-type").val(paramDataUserObj.customerType);
        $("#select-register-status").val(paramDataUserObj.registerStatus);
    }
    //hàm thu thập dữ liệu trên form
    function getFormData(){
        var vUpdateInfoObj = new Object();
        vUpdateInfoObj.firstname = $(gElementFirstName).val();
        vUpdateInfoObj.lastname = $(gElementLastName).val();
        vUpdateInfoObj.subject = $(gElementSubject).val();
        vUpdateInfoObj.country = $(gElementCountry).val();
        vUpdateInfoObj.customerType = $(gElementCustomerType).val();
        return vUpdateInfoObj;
    }
    //hàm validate data trên form
    function validateFormData(paramUserObject){
        if (paramUserObject.firstname == "" ||
        paramUserObject.lastname == "" ||
        paramUserObject.subject == "" ||
        paramUserObject.country == "" ||
        paramUserObject.customerType == ""){
            alert ("Thông tin không được để trống");
            return false;
        }
        return true;
    }
    //hàm gọi API cập nhật user
    function callAjaxApiUpdateUser(paramEditedUserObject){
        "use strict";
        //b1: get data user id
        var vUserId = getCurrentUserId();
        //b3: get userlist
        var vJsonString = JSON.stringify(paramEditedUserObject);
        $.ajax({
            url: "http://203.171.20.210:8080/devcamp-register-java-api/users/" + vUserId,
            type: "PUT",
            contentType: "application/json", // added content type
            data: vJsonString,
            success: updateUserSuccess,
            error: updateUserError 
        });
    }
    //xử lý response success
    function updateUserSuccess(paramResponse){
        alert("User Id: " + paramResponse.id + " is updated succesfully!");
        //quay lại trang user list
        window.location.href = "userList.html";
        console.log("%cUPDATED INFORMATION: ", "color:orange");
        console.log(paramResponse);
    }
    //xử lý response error
    function updateUserError(paramAjaxContext){
        alert(paramAjaxContext.responseText)
    }
</script>
</html>